"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class HpoTerm(ProtocolElement):
    """
    This defines an HPO term and its modifiers (possibly multiple)     If
    HPO term presence is unknown we don't have a entry on the list
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "term",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_5 import participant as participant_1_5_0

        return {
            "modifiers": participant_1_5_0.HpoTermModifiers,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_5 import participant as participant_1_5_0

        return {
            "ageOfOnset": participant_1_5_0.AgeOfOnset,
            "termPresence": participant_1_5_0.TernaryOption,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_5 import participant as participant_1_5_0

        return {
            "org.gel.models.participant.avro.AgeOfOnset": participant_1_5_0.AgeOfOnset,
            "org.gel.models.participant.avro.HpoTermModifiers": participant_1_5_0.HpoTermModifiers,
            "org.gel.models.participant.avro.TernaryOption": participant_1_5_0.TernaryOption,
            "org.gel.models.participant.avro.HpoTerm": participant_1_5_0.HpoTerm,
        }

    __slots__ = [
        "term",
        "ageOfOnset",
        "hpoBuildNumber",
        "modifiers",
        "termPresence",
    ]

    def __init__(
        self,
        term,
        ageOfOnset=None,
        hpoBuildNumber=None,
        modifiers=None,
        termPresence=None,
        validate=None,
        **kwargs
    ):
        """Initialise the participant_1_5_0.HpoTerm model.

        :param term:
            Identifier of the HPO term
        :type term: str
        :param ageOfOnset:
            Age of onset in months
        :type ageOfOnset: None | AgeOfOnset
        :param hpoBuildNumber:
            hpoBuildNumber
        :type hpoBuildNumber: None | str
        :param modifiers:
            Modifier associated with the HPO term
        :type modifiers: None | list[HpoTermModifiers]
        :param termPresence:
            This is whether the term is present in the participant (default is
            unknown) yes=term is present in participant,
            no=term is not present
        :type termPresence: None | TernaryOption
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.0"
